<?php
/*
 *   PhotoBase, PHP & MySQL based web photo gallery
 *   Copyright 2007,2008 Martin Plicka
 *   
 *   This file is part of PhotoBase.
 *
 *   PhotoBase is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *   PhotoBase is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with PhotoBase.  If not, see <http://www.gnu.org/licenses/>.
 */      
 
/**
 * editgal.php
 * 
 * Provides gallery creating, editing and deleting
 *    
 * @author Martin Plicka 
 * @version 0.9
 * 
 * 
 * GET [action] = new
 *                edit
 *                delete  
 * GET[state] = 0 - form / sending form
 *              1 - acknowledgement
 * GET[id]    =  ID of gallery to be modified/deleted 
 * GET[category] - category ID, used as default value in edit/new form 
 * 
 * POST[send] = submit button  
 * POST[name] = gallery name
 * POST[description] = gallery description  
 * POST[category]   = category ID where gallery will be inserted
 */ 
 
require_once './inc/tools.inc.php';
require_once './inc/login.inc.php';

$action = isset($_GET["action"])?$_GET["action"]:"new";

$state = isset($_GET["state"])?(int)$_GET["state"]:0;
if ($state < 0 || $state>1) $state = 0;

$id = isset($_GET["id"])?(int)$_GET["id"]:0;

$category = isset($_GET["category"])?(int)$_GET["category"]:0;

switch($action) {
   case "delete":  
                   $LOCATION = "Smazání galerie";
                   break;
   case "edit":
                   $LOCATION = "Editace galerie";
                   break;
   case "new":
   default:        
                   $action = "new";
                   $LOCATION = "Vytvoření galerie";
                   break;
}
$PAGER = "Krok ".($state+1);


switch ($state){
  case 1:
          include "./inc/header.inc.php";
          echo "
            <h1>Provedeno</h1>\n
          ";
          switch($action){
                case "new":
                   echo "
                      <p>Galerie byla vytvořena. <a href=\"./list.php?what=photos&amp;id=$id\">Přejít</a>.</p>
                   ";
                   break;
                case "edit":
                   echo "
                      <p>Galerie byla upravena. <a href=\"./list.php?what=photos&amp;id=$id\">Přejít</a>.</p>
                   ";
                   break;
                case "delete":
                   echo "
                      <p>Galerie byla smazana. <a href=\"./list.php?what=gal&amp;id=$id\">Přejít na seznam galerií</a>.</p>
                   ";
                   break;
          }
          include "./inc/footer.inc.php";
          break;
          
  case 0:
         switch($action) {
             case "delete":  
                   $query = "SELECT user FROM galleries WHERE id=$id";
                   $res = db_query($query);
                   db_error_on_empty($res);
                   $row = mysql_fetch_row($res);
                   mysql_free_result($res);
                   if (!login_isAdmin() && login_id() != $row[0]) error("Nejste vlastník ani administrátor, abyste mohli smazat galerii");
                   break;
             case "edit":
                   $query = "SELECT user FROM galleries WHERE id=$id";
                   $res = db_query($query);
                   db_error_on_empty($res);
                   $row = mysql_fetch_row($res);
                   mysql_free_result($res);
                   if (!login_isAdmin() && login_id() != $row[0]) 
                      error("Nejste vlastník ani administrátor, abyste mohli editovat galerii");
                   break;
             case "new":
             default: 
                   if (!login_isCreator()) error("Nejste creator, abyste mohli založit galerii");
                   break;
         }
         $name ="";
         $description = "";

         //stisknuto tlacitko odeslat
         if (isset($_POST["send"])) {
           $name = (unsafe_post("name"));
           $description = (unsafe_post("description"));
           $category = isset($_POST["category"])?(int)$_POST["category"]:0;
           $break = false;
           switch($action){
              case "edit":
                     if (!ereg("[^ ]+",$name)) { //pokud jmeno obsahuje neco krome mezery
                        $msg .= "Jméno galerie nesmí být prázdné<br />"; $break=true;
                     } 
                     if (!ereg("[^ ]+",$description)) { //pokud jmeno obsahuje neco krome mezery
                        $msg .= "Popis nesmí být prázdný<br />"; $break=true;
                     } 
                     if ($break) break;
                     
                     $name1 = (safe_post("name"));
                     $description1 = (safe_post("description"));
           
                     $query = "UPDATE galleries SET name='$name1', description='$description1', category=$category WHERE id=$id";
                        
                     $res = db_query($query,false);
                     if ($res) location("./editgal.php?action=$action&state=1&id=$id");
                     if (mysql_errno() > 0 && mysql_errno() != 1062) db_error (mysql_errno());
                     $msg = "Jméno v kategorii již existuje, nebo kategorie není platná";
                     
                  break;
              case "new":
                     if (!ereg("[^ ]+",$name)) { //pokud jmeno obsahuje neco krome mezery
                        $msg .= "Jméno galerie nesmí být prázdné<br />"; $break=true;
                     } 
                     if (!ereg("[^ ]+",$description)) { //pokud jmeno obsahuje neco krome mezery
                        $msg .= "Popis nesmí být prázdný<br />"; $break=true;
                     } 
                     if ($break) break;
                     
                     $name1 = (safe_post("name"));
                     $description1 = (safe_post("description"));
           
                     $query = "INSERT INTO galleries (name,description,category,user) VALUES ('$name1','$description1',$category,".login_id().");";
                     $res = db_query($query,false);
                     if ($res) location("./editgal.php?action=$action&state=1&id=".mysql_insert_id());
                     if (mysql_errno() > 0 && mysql_errno() != 1062) db_error ("");
                     $msg = "Jméno v kategorii již existuje, nebo kategorie není platná";
                  break;
              case "delete":
                    if ($_POST["send"]=="Ne") location ("./");
                    
                    // nejprve najdu soubory, ktere musim smazat
                    $query = "SELECT url FROM photos WHERE gallery=$id";
                    $res = db_query($query);
                    while ($row = mysql_fetch_row($res)) {
                      //smazu jak velky soubor, tak nahledy z cache
                      @unlink("./photos/{$row[0]}");
                      foreach ($THUMB_SIZE as $tmp){
                        @unlink("./thumbs/{$tmp["w"]}-{$tmp["h"]}-{$row[0]}");
                      }
                    }
                    mysql_free_result($res);

                    $query = "DELETE FROM photos WHERE gallery = $id";
                    db_query($query); //chyby osetruje db_query();

                    $query = "DELETE FROM galleries WHERE id = $id";
                    db_query($query); //chyby osetruje db_query();
                    
                    location("./editgal.php?action=$action&state=1");
                  break;     
                  
           }
        }
        
        /**
         * Loading existing gallery
         */                         
        else {
           switch ($action){
             case "edit":
                  $query = "SELECT name, description, category FROM galleries WHERE id=$id";
                  $res = db_query ($query);
                  db_error_on_empty($res);
                  list ($name, $description, $category) = mysql_fetch_row($res);
                  mysql_free_result($res);
                 break;
           }
        
        }
        
        
        include "./inc/header.inc.php";

        switch ($action){
           case "edit": case "new":
                   
                   $name = hsc($name);
                   $description = hsc($description);

                   echo "
                   <script type=\"text/javascript\">
                      function check(){
                         a = document.getElementById(\"name1\");
                         if (! /[^ ]+/.test(a.value)) {
                            window.alert(\"Zadejte název\");
                            a.focus();
                            return false;
                         }
                         a = document.getElementById(\"description1\");
                         if (! /[^ ]+/.test(a.value)) {
                            window.alert(\"Zadejte popis\");
                            a.focus();
                            return false;
                         }
                         return true;
                      }
                   </script> 
                   ";
                   echo "
                     <div class=\"error\">$msg</div>
                   ";
                   echo "
                      <form action=\"./editgal.php?action=$action&amp;id=$id\" method=\"post\" onsubmit=\"return check();\">
                   ";
                      
                   $query = "SELECT c.id, c.name, count(g.id) FROM categories c LEFT JOIN galleries g ON (g.category = c.id) GROUP BY c.id ORDER BY c.name;";
                   $res = db_query($query);
                
                   if (db_empty($res)) error("Neexistuje řádná kategorie, v které lze galerii založit. Kontaktujte administrátora");
                   echo "
                     <label for=\"category1\" class=\"mandatory\">Kategorie *</label><select name=\"category\" id=\"category1\">
                   ";
                   
                   while ($row = mysql_fetch_row($res)) {
                     echo "
                       <option value=\"{$row[0]}\"".(($row[0]==$category)?" selected=\"selected\"":"").">".hsc($row[1])." ({$row[2]})</option>
                     ";
                   }
                   echo "
                     </select>
                   ";
                   
                   mysql_free_result($res);
                   
                   echo "
                      <label for=\"name1\" class=\"mandatory\">Jméno galerie *</label><input type=\"text\" id=\"name1\" name=\"name\" value=\"$name\" maxlength=\"40\" size=\"40\" /><br />
                      <label for=\"description1\" class=\"mandatory\">Popis galerie *</label><input type=\"text\" id=\"description1\" name=\"description\" value=\"$description\" maxlength=\"100\" size=\"50\" /><br />
                      <br />
                      Povinné položky jsou označeny hvězdičkou<br /><input type=\"submit\" name=\"send\" id=\"send1\" value=\"Uložit\" />
                     </form>
                   ";
                   break;
                   
           case "delete":
                  echo "
                    <div class=\"error\">
                       Opravdu smazat galerii<br /> a všechny obsažené fotografie?
                    </div>
                    <form action=\"./editgal.php?action=$action&amp;id=$id\" method=\"post\">
                      Tuto akci nelze vrátit.<br />
                      <input type=\"submit\" name=\"send\" value=\"Ano\" />
                      <input type=\"submit\" name=\"send\" value=\"Ne\" onclick=\"history.go(-1); return false;\" />
                    </form>";
                  break;
        }
        include "./inc/footer.inc.php";
    
}
?>
