<?php
/*
 *   PhotoBase, PHP & MySQL based web photo gallery
 *   Copyright 2007,2008 Martin Plicka
 *   
 *   This file is part of PhotoBase.
 *
 *   PhotoBase is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *   PhotoBase is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with PhotoBase.  If not, see <http://www.gnu.org/licenses/>.
 */      
 
/**
 * editphoto.php
 * 
 * Provides adding/removing/modifying photos
 *    
 * @author Martin Plicka 
 * @version 0.9
 * 
 * 
 * GET [action] = new
 *                edit
 *                delete  
 * GET[state] = 0 - form
 *              1 - acknowledgement
 * GET[id]    =   ID of removed, modified
 * GET[gallery] = default gallery ID for photo, used in new/edit form
 *   
 * POST[send] = submit button  
 * POST [description] = photo description
 * POST [picture]  = uploaded picture 
 * POST [gallery]  = gallery ID
 */ 
 
require_once './inc/tools.inc.php';
require_once './inc/login.inc.php';

$action = isset($_GET["action"])?$_GET["action"]:"new";

$state = isset($_GET["state"])?(int)$_GET["state"]:0;
if ($state < 0 || $state>1) $state = 0;

$id = isset($_GET["id"])?(int)$_GET["id"]:0;

$gallery = isset($_GET["gallery"])?(int)$_GET["gallery"]:0;

switch($action) {
   case "delete":  
                   $TITLE = $LOCATION = "Smazání fotografie";
                   break;
   case "edit":
                   $TITLE = $LOCATION = "Editace fotografie";
                   break;
   case "new":
   default:        $action = "new";
                   $TITLE = $LOCATION = "Vložení fotografie";
                   break;
}
$PAGER = "Krok ".($state+1);


switch ($state){
  case 1:
          include "./inc/header.inc.php";
          echo "<h1>Provedeno</h1>\n";
          switch($action){
                case "new":
                   echo "<p>Fotografie byla vložena. <a href=\"./view.php?id=$id\">Přejít</a>, <a href=\"./editphoto.php?action=new&amp;gallery=$gallery\">Vložit další</a>.</p>\n";
                   break;
                case "edit":
                   echo "<p>Fotografie byla upravena. <a href=\"./view.php?id=$id\">Přejít</a>.</p>\n";
                   break;
                case "delete":
                   echo "<p>Fotografie byla smazána. <a href=\"./list.php?what=gal\">Přejít na seznam galerií</a>.</p>\n";
                   break;
          
          
          }
          include "./inc/footer.inc.php";
          break;
          
  case 0:
  
         switch($action) {
             case "delete":  
                   $query = "SELECT g.user FROM galleries g JOIN photos p ON (p.gallery = g.id) WHERE p.id=$id";
                   $res = db_query($query);
                   db_error_on_empty($res);
                   $row = mysql_fetch_row($res);
                   mysql_free_result($res);
                   if (!login_isAdmin() && login_id() != $row[0]) error("Nejste vlastník ani administrátor, abyste mohli smazat fotografii");
                   break;
             case "edit":
                   $query = "SELECT g.user FROM galleries g JOIN photos p ON (p.gallery = g.id) WHERE p.id=$id";
                   $res = db_query($query);
                   db_error_on_empty($res);
                   $row = mysql_fetch_row($res);
                   mysql_free_result($res);
                   if (!login_isAdmin() && login_id() != $row[0]) 
                      error("Nejste vlastník ani administrátor, abyste mohli editovat fotografii");
                   $owner = $row[0];
                   break;
            case "new":
            default:   
                   if (!login_isCreator()) error("Nejste creator, abyste mohli vložit fotografii");
                   break;
}
         $description = "";
         $url = "";

         //stisknuto tlacitko odeslat
         if (isset($_POST["send"])) {
           $description = (unsafe_post("description"));
           $gallery = isset($_POST["gallery"])?(int)$_POST["gallery"]:0;
           

           switch($action){
              case "edit":
                     $description1 = (safe_post("description"));

                     //overeni, zda presouvame mezi galeriemi stejneho uzivatele
                     $query = "SELECT id FROM galleries WHERE id=$gallery AND user=$owner;";
                     $res=db_query($query);
                     db_error_on_empty($res);
                     mysql_free_result($res);

                     $query = "UPDATE photos SET description='$description1', gallery=$gallery WHERE id=$id";
                        
                     $res = db_query($query);
                     if ($res) location("./editphoto.php?action=$action&state=1&id=$id");
           
                  break;
              case "new":
                     if (ereg("[^ ]+",$_FILES['picture']['tmp_name'])) {
                      $file = $_FILES['picture'];
                      if ($file["type"]!="image/jpeg" &&  $file["type"]!="image/pjpeg") {$msg = "Obrazek neni JPEG, ale ".$file["type"]; break;}
                      if ($file["size"]>$UPLOAD_MAX_SIZE) {$msg = "Obrazek je prilis velky"; break;}
                      $size = getimagesize($_FILES['picture']['tmp_name']);
                      $ratio = (double)$size[0]/(double)$size[1];
                      if ($ratio > 5 || $ratio < 0.2) {$msg = "Obrazek ma prilis vysoky (vice nez 1:5) pomer stran"; break;}
                     }
                     else{
                      $msg = "Žádný, neexistující, nebo příliš velký soubor";
                      break;
                     }
                     
                     //overeni, zda ukladame do galerie daneho uzivatele
                     $query = "SELECT id FROM galleries WHERE id=$gallery AND user=".login_id().";";
                     $res=db_query($query);
                     db_error_on_empty($res);
                     mysql_free_result($res);

                     
                     $description1 = (safe_post("description"));
                     $query = "INSERT INTO photos (description,gallery,url) VALUES ('$description1',$gallery,'error_when_found');";
                     $res = db_query($query);
                     $id = mysql_insert_id();
                     $new_url = str_pad(login_id(), 3, "0", STR_PAD_LEFT)."_".str_pad($id, 10, "0", STR_PAD_LEFT).".jpg";
                     $query = "UPDATE photos SET url = '$new_url' WHERE id = $id;";
                     db_query($query);
                     if (!move_uploaded_file($_FILES['picture']['tmp_name'], "./photos/$new_url")) error ("Doslo k chybe pri uploadu");
                     if ($res) location("./editphoto.php?action=$action&state=1&id=$id&gallery=$gallery");
                  break;
              case "delete":
                    if ($_POST["send"]=="Ne") location ("./");
 
                    // nejprve najdu soubory, ktere musim smazat
                    $query = "SELECT url FROM photos WHERE id=$id";
                    $res = db_query($query);
                    db_error_on_empty($res);
                    $row = mysql_fetch_row($res);
                    mysql_free_result($res);
                    
                    //smazu jak velky soubor, tak nahledy z cache
                    @unlink("./photos/{$row[0]}");
                    foreach ($THUMB_SIZE as $tmp){
                        @unlink("./thumbs/{$tmp["w"]}-{$tmp["h"]}-{$row[0]}");
                    }
                    
                    $query = "DELETE FROM photos WHERE id = $id";
                    db_query($query); //chyby osetruje db_query();
                    location("./editphoto.php?action=$action&state=1");
                  break;     
                  
           }
        }
        //prvni vstup na stranku, tj. napriklad nacteni editovane polozky
        else {
           switch ($action){
             case "edit":
                  $query = "SELECT description, gallery, url FROM photos WHERE id=$id";
                  $res = db_query ($query);
                  db_error_on_empty($res);
                  list ($description, $gallery, $url) = mysql_fetch_row($res);
                  mysql_free_result($res);
                 break;
           }
        
        }
        
        
        // odeslano, i neodeslano      
        
        include "./inc/header.inc.php";

        switch ($action){
           case "edit": case "new":
                   
                   $description = hsc($description);

                   echo "<div class=\"error\">$msg</div>
                   <script type=\"text/javascript\">
                      function check(){
                         a = document.getElementById('picture1');
                         if (a && ! /[^ ]+/.test(a.value)) {
                            window.alert('Vložte soubor');
                            a.focus();
                            return false;
                         }
                         return true;
                      }
                      
                    </script> 
                   <form enctype=\"multipart/form-data\" action=\"./editphoto.php?action=$action&amp;id=$id\" method=\"post\" onsubmit=\"return check();\">\n";
                      if ($action == "edit")
                      $query = "SELECT c.id,c.name,g.id,g.name FROM categories c JOIN galleries g ON (g.category = c.id) WHERE g.user=$owner ORDER BY c.name, g.name;";
                      else $query = "SELECT c.id,c.name,g.id,g.name FROM categories c JOIN galleries g ON (g.category = c.id) WHERE g.user=".login_id()." ORDER BY c.name, g.name;";
                      $res = db_query($query);
                      if (db_empty($res)) error("Nevlastníte žádnou galerii. Musíte nějakou založit");
                      if ($action == "edit") {
                        echo "<img src=\"./thumb.php?src=".urlencode($url)."&amp;size=0\" alt=\"Nahled\" /><br />\n";
                      }
                      else {
                        echo "<input type=\"hidden\" name=\"MAX_FILE_SIZE\" value=\"$UPLOAD_MAX_SIZE\" />
<label for=\"picture1\" class=\"mandatory\">Soubor fotografie * (JPEG, max. velikost $UPLOAD_MAX_SIZE_HR)</label><input type=\"file\" name=\"picture\" id=\"picture1\" value=\"{$file['name']}\" onchange=\"thumb();\"/><br />\n";
                      }
                      echo "<label for=\"gallery1\" class=\"mandatory\">Galerie *</label><select name=\"gallery\" id=\"gallery1\">\n";
                      $i=0;
                      while ($row = mysql_fetch_row($res)) {
                        if($row[0]!=$i) {
                           if ($i!=0) echo "</optgroup>\n";
                           echo "<optgroup label=\"{$row[1]}\">\n";
                           $i = $row[0];
                        }
                        echo "<option value=\"{$row[2]}\"".(($row[2]==$gallery)?" selected=\"selected\"":"").">".hsc($row[3])."</option>\n";
                      }
                      echo "</optgroup></select><br />\n";
                      
                      mysql_free_result($res);
                      
                      echo"
                        <label for=\"description1\">Popis obrázku:</label><input type=\"text\" id=\"description1\" name=\"description\" value=\"$description\" maxlength=\"100\" size=\"50\" /><br />
                        <br />Povinné položky jsou označeny hvězdičkou<br /><input type=\"submit\" name=\"send\" id=\"send1\" value=\"Uložit\" />
                      </form>
                   ";
                break;
           case "delete":
                  echo "<div class=\"msg\">Opravdu smazat fotografii?</div><form action=\"./editphoto.php?action=$action&amp;id=$id\" method=\"post\">
                        <input type=\"submit\" name=\"send\" value=\"Ano\" />
                        <input type=\"submit\" name=\"send\" value=\"Ne\" onclick=\"history.go(-1); return false;\" />
                      </form>";
                break;
        }
                   include "./inc/footer.inc.php";
    
}
?>
