<?php

/*
 *   PhotoBase, PHP & MySQL based web photo gallery
 *   Copyright 2007,2008 Martin Plicka
 *   
 *   This file is part of PhotoBase.
 *
 *   PhotoBase is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *   PhotoBase is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with PhotoBase.  If not, see <http://www.gnu.org/licenses/>.
 */      
 
/**
 * edituser.php
 * 
 * Provides editing/removing/creating users
 *    
 * @author Martin Plicka 
 * @version 0.9
 * 
 *  
 * Parametres: 
 *   GET[state] = 0 - form
 *                1 - acknowledgement
 *   GET[action] = grant - grants gallery creating right
 *               = delete
 *               = (other) - editing
 *   GET[id] = ID     
 *    
 *   POST[send] = submit button
 *   POST[name] 
 *   POST[email]
 *   POST[pass1]
 *   POST[pass2]
 *   POST[rights] = access rights
 *   POST[wantcreate] = gallery creator request 
 */
 

require_once './inc/login.inc.php';
require_once './inc/tools.inc.php'; 
 
if (!login_isLogged()) error("Upravit udaje muze jen registrovany uzivatel.");

$state = isset($_GET["state"])?(int)$_GET["state"]:0;
$id = isset($_GET["id"])?(int)$_GET["id"]:0;


if (!login_isAdmin() && $id != login_id()) {
  error ("Nejste dany uzivatel, ani administrator");
  exit;
}

if (login_id() != 1 && $id == 1) {
  error ("root je nedotknutelný !!!");
  exit;
}

$action = isset($_GET["action"])?$_GET["action"]:"";

/**
 * grant gallery creation right
 */ 
if ($action=="grant" && login_isAdmin()) {

    $query = "UPDATE users SET rights = (rights & 254 | ".RIGHTS_CREATOR.") WHERE id=$id;";
    db_query($query);
    if (isset($_GET["goback"])) location(urldecode($_GET["goback"]));
    else location ("./userlist.php");
    exit;
}

/**
 * Delete user, root if forbiden to delete !
 */ 
if ($action=="delete" && login_isAdmin()) {
    if ($id == 1) {
      error ("root je nedotknutelný !!!");
      exit;
    }
    $LOCATION = $TITLE = "Smazání uživatele";
    $PAGER = "Krok ".($state+1);
    if ($state==1) {
        include "./inc/header.inc.php";
        echo "
          <p>Uživatel byl smazán včetně jeho fotografií. <a href=\"./userlist.php\">Přejít na seznam uživatelů</a>.</p>
        ";
        include "./inc/footer.inc.php";
    }
    else {
       if (isset($_POST["send"])){
          if ($_POST["send"]=="Ne") location ("./userlist.php");
          // nejprve najdu soubory, ktere musim smazat
          $query = "SELECT p.url FROM galleries g JOIN photos p ON(p.gallery = g.id) WHERE g.user=$id";
          $res = db_query($query);
          while ($row = mysql_fetch_row($res)) {
             //smazu jak velky soubor, tak nahledy z cache
             @unlink("./photos/{$row[0]}");
             foreach ($THUMB_SIZE as $tmp){
                @unlink("./thumbs/{$tmp["w"]}-{$tmp["h"]}-{$row[0]}");
             }
          }
          mysql_free_result($res);
                    
          $query = "DELETE FROM users WHERE id = $id";
          db_query($query); //chyby osetruje db_query();
          location("./edituser.php?action=$action&state=1");
          
          
       }
       
       include "./inc/header.inc.php";
       echo "
          <div class=\"error\">
            Opravdu smazat uživatele <br /> a všechny jeho galerie a fotografie?
          </div>
          Tuto akci nelze vrátit
          <form action=\"./edituser.php?action=$action&amp;id=$id\" method=\"post\">
            <input type=\"submit\" name=\"send\" value=\"Ano\" />
            <input type=\"submit\" name=\"send\" value=\"Ne\" onclick=\"history.go(-1); return false;\" />
          </form>
       ";
        include "./inc/footer.inc.php";
       
    }
    exit;
}


/**
 * Other = editing
 */
  
$name="";
$email="";
$pass1="";
$pass2="";
$wantcreate=0;
$rights=0;

$break = false;
$msg = "";

/**
 * something send via POST
 */ 
if (isset($_POST["send"])) {
   $name=unsafe_post("name");
   $loginname=unsafe_post("loginname");
   $email=unsafe_post("email");
   $pass1=unsafe_post("pass1");
   $pass2=unsafe_post("pass2");
   $wantcreate=(int)unsafe_post("wantcreate");
   $rights = is_array($_POST["rights"])?array_sum($_POST["rights"]):0;

   /**
    * Input checkout
    */          
   if (! ereg("[[:alpha:]]{2,}",$name)) {
       $msg.="Jméno musí obsahovat alespoň 2 písmena za sebou.<br />"; $break=true;
   }

   if (! ereg("^[_a-zA-Z0-9\.\-]+@[_a-zA-Z0-9\.\-]+\.[a-zA-Z]{2,4}$",$email)) {
       $msg.="Neplatný formát emailu.<br />"; $break=true;
   }
   
   if (strlen($pass) != 0 && strlen($pass1)<5) {
       $msg.="Heslo musi byt alespon 5 znaku"; $break=true;
   }
   else if ($pass1 != $pass2) {
       $msg.="Hesla v obou polickach nesouhlasi"; $break = true;
   }
   
   /**
    * Some error found
    */           
   if (! $break) {
       $name1 = safe_post("name");
       $email1 = safe_post("email");
       $pass11 = md5($pass1);
       if (login_isAdmin()){
         if ($id != 1) $rig = "rights = $rights, ";
         else $rig = ""; //root je chranen
       }
       else {
         $rig = "rights = (rights & 254 | ".($wantcreate?"1":"0")."), ";
         
       }
       $query = "UPDATE users SET name='$name1', ".($pass1!=""?"pass='$pass11', ":"")."$rig email='$email1' WHERE id=$id;";
       
       $res = db_query($query);
       location("./edituser.php?id=$id&state=1");
   }
}

/**
 * Nothing posted. Load user for editing.
 */ 
else {
  $query = "SELECT login, name, email, rights+0 FROM users WHERE id=$id;";
  $res = db_query($query);
  if (db_empty($res)) error ("Neplatný uživatel");
  list($loginname, $name, $email, $rights) = mysql_fetch_row($res);
  $wantcreate = $rights & 1;
  mysql_free_result($res);

}
    
$LOCATION = "Editace uživatele \"$loginname\"";
$TITLE = "Editace uživatele";
include "./inc/header.inc.php";

/**
 * Javascript input checks
 */ 
?>
<script type="text/javascript">
   function check_reg(){
       a = document.getElementById("name1");
       if (! /[^ ]{2}/.test(a.value)) {
           window.alert("Neplatné jméno, musí obsahovat alespoň dvě písmena za sebou");
           a.focus();
           return false;
       }
       a = document.getElementById("email1");
       if (! /^[_a-zA-Z0-9\.\-]+@[_a-zA-Z0-9\.\-]+\.[a-zA-Z]{2,4}$/.test(a.value)) {
           window.alert("Neplatný email");
           a.focus();
           return false;
       }
       a = document.getElementById("pass11");
       b = document.getElementById("pass21");
       if (a.value.length!=0 && a.value.length < 5){
           window.alert("Heslo musí být minimálně 5 znaků");
           a.focus();
           return false;
       }
       else if (a.value != b.value){
           window.alert("Hesla v obou políčkách se neshodují");
           b.focus();
           return false;
       }
       
       return true;
   }
   
   function color_name() {
       a = document.getElementById("name1");
       if (! /[^ ]{2}/.test(a.value)) 
          a.style.background = '#ffcc99';
       else 
          a.style.background = 'none';
   }
   
   
   function color_email() {
       a = document.getElementById("email1");
       if (! /^[_a-zA-Z0-9\.\-]+@[_a-zA-Z0-9\.\-]+\.[a-zA-Z]{2,4}$/.test(a.value)) 
          a.style.background = '#ffcc99';
       else 
          a.style.background = 'none';
   }
   
   function color_pass (){
       a = document.getElementById("pass11");
       b = document.getElementById("pass21");
       if (a.value.length < 5 && a.value.length>0){
           a.style.background = '#ffcc99';
           b.style.background = 'none';
       }
       else if (a.value != b.value){
           b.style.background = '#ffcc99';
           a.style.background = 'none';
       }
       else {
           a.style.background = 'none';
           b.style.background = 'none';         
       }
   }

</script>

<?

if ($state==1) echo "
  <div class=\"msg\">Uloženo</div>
";

echo "
  <div class=\"error\">$msg</div>
  <form action=\"./edituser.php?id=$id\" method=\"post\" onsubmit=\"return check_reg();\">
    <input type=\"hidden\" name=\"loginname\" value=\"$loginname\" />
    <label for=\"name1\" class=\"mandatory\">Jméno * (bude se zobrazovat u galerií, příspěvků)</label>
      <input type=\"text\" name=\"name\" value=\"".hsc($name)."\" maxlength=\"30\" id=\"name1\" onkeyup=\"color_name();\" /><br />
    <label for=\"email1\" class=\"mandatory\">E-mail *</label>
      <input type=\"text\" name=\"email\" value=\"".hsc($email)."\" maxlength=\"50\" id=\"email1\" onkeyup=\"color_email();\" /><br />
    <label for=\"pass11\">Heslo (zadejte jen v případě změny, min. 5 znaků)</label>
      <input type=\"password\" name=\"pass1\" value=\"".hsc($pass1)."\" id=\"pass11\" onkeyup=\"color_pass();\" /><br />
    <label for=\"pass21\">Heslo znovu</label>
      <input type=\"password\" name=\"pass2\" value=\"".hsc($pass2)."\" id=\"pass21\" onkeyup=\"color_pass();\" /><br />
";
if (login_isAdmin() && $id!=1) { //cannot edit rights for root

  echo "
    <label>Práva</label>
      <input class=\"inline\" type=\"checkbox\"  name=\"rights[]\" id=\"rights2\" value=\"2\"".(($rights & 2)?" checked=\"checked\"":"")." /><label class=\"inline\" for=\"rights2\">! {$LOGIN_RIGHT_NAME[2]} ! ".($id == login_id()?"&nbsp;&nbsp;<b>Varování:</b> Pokud si toto právo odeberete, vrátit vám jej může pouze jiný administrátor":"")."</label><br />
      <input class=\"inline\" type=\"checkbox\"  name=\"rights[]\" id=\"rights4\" value=\"4\"".(($rights & 4)?" checked=\"checked\"":"")." /><label class=\"inline\" for=\"rights4\">{$LOGIN_RIGHT_NAME[4]}</label><br />
      <input class=\"inline\" type=\"checkbox\"  name=\"rights[]\" id=\"rights8\" value=\"8\"".(($rights & 8)?" checked=\"checked\"":"")." /><label class=\"inline\" for=\"rights8\">{$LOGIN_RIGHT_NAME[8]}</label><br />
      <input class=\"inline\" type=\"checkbox\" name=\"rights[]\" id=\"rights16\" value=\"16\"".(($rights & 16)?" checked=\"checked\"":"")." /><label class=\"inline\" for=\"rights16\">{$LOGIN_RIGHT_NAME[16]}</label><br />
    <br />
  ";
}

if (!login_isAdmin() && !($rights & RIGHTS_CREATOR)) { // i'm not admin, and want to create galleries
  echo "
    <input class=\"inline\" type=\"checkbox\" name=\"wantcreate\" id=\"wantcreate1\" value=\"1\"".(($wantcreate==1)?" checked=\"checked\"":"")."/><label class=\"inline\" for=\"wantcreate1\">Chci vytvářet vlastní galerie fotek (zaškrtněte).</label>
    <br />
  ";
}

echo "
    <br />
    Povinné položky jsou označeny hvězdičkou.
    <br />
    <input type=\"submit\" name=\"send\" value=\"Odeslat\" />
                              
  </form>
";
include "./inc/footer.inc.php";

?>
