<?php
/*
 *   PhotoBase, PHP & MySQL based web photo gallery
 *   Copyright 2007,2008 Martin Plicka
 *   
 *   This file is part of PhotoBase.
 *
 *   PhotoBase is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *   PhotoBase is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with PhotoBase.  If not, see <http://www.gnu.org/licenses/>.
 */     

/**
 * inc/db.inc.php
 * 
 * basic functions for DB connection. When included, connection is estabilished automaticaly
 *  
 * @version 0.9
 * @author Martin Plicka
 *    
 */  

require_once './inc/setup.inc.php';
require_once './inc/tools.inc.php';

/**
 * connection handler
 */ 
$DB=0;

/**
 * Connects to database.
 * @param host MySQL server address
 * @param user username
 * @param pass password
 * @param dbname name of database for PhotoBase to use
 * @return connection handler
 */        
function db_connect($host, $user, $pass, $dbname){
  $conn = @mysql_pconnect($host, $user, $pass) or db_error("Chyba spojeni s databazi");
  @mysql_select_db($dbname, $conn) or db_error("Chyba spojeni s databazi");
  return $conn;
}

/**
 * Prints out message when databaze error ocurs.
 * @param desc Error description
 */ 
function db_error ($desc){
  if ($desc=="") $desc = mysql_errno(). " - ". mysql_error();
  error("CHYBA DATABÁZE: ".$desc);
}

/** 
 * Queries database
 * @param query query text
 * @param check true, when error chechking have to be performed
 * @return result handler or true (for INSERT command etc.), otherwise false for error.
 */    
function db_query($query, $check=true){
   global $DB;
   $tmp = @mysql_query($query, $DB);
   if (! $check) return $tmp;
   if ($tmp) return $tmp; else db_error ("Neplatny dotaz do databaze: ".mysql_error($DB));
}

/**
 * Checks if some data has returned.
 * @param result result handler
 * @return true, if no rows returned
 */   
function db_empty($result) {
    return mysql_num_rows($result)==0;
}
  
/**
 * Prints out generic error, when number of returned rows is equal to zero.
 * @param result
 */  
function db_error_on_empty($result){
   if (@db_empty($result)) db_error("Neplatne parametry v URL");
}

/**
 * Connects to database with every inclusion.
 */
if (!(isset($DB_NO_CONNECTION) && $DB_NO_CONNECTION == 1)) {
  $DB = db_connect ($DB_HOST, $DB_USER, $DB_PASS, $DB_NAME);
  db_query("SET NAMES 'utf8';");
}

?>
