<?
/*
 *   PhotoBase, PHP & MySQL based web photo gallery
 *   Copyright 2007,2008 Martin Plicka
 *   
 *   This file is part of PhotoBase.
 *
 *   PhotoBase is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *   PhotoBase is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with PhotoBase.  If not, see <http://www.gnu.org/licenses/>.
 */     

/**
 * inc/header.inc.php
 * 
 * Includes page header.
 *  
 * @version 0.9
 * @author Martin Plicka
 *      
 *          
 * Uses these global variables, their must be set before file is included.
 * Otherwise, their meaning is ignored.
 *   
 *   $LOCATION - gallery postion, displayed as: PhotoBase / $LOCATION
 *   $TITLE - page title, displayed in browser window caption as: PhotoBase :: $TITLE
 *   $PAGER - paging paragraph     
 */ 

require_once './inc/login.inc.php';
require_once './inc/setup.inc.php';

//prevent from caching
header("Cache-Control: no-cache, must-revalidate"); // HTTP/1.1
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT"); // Date in the past

echo '<?xml version="1.0" ?>';
?>
 <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
   "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
 <html xmlns="http://www.w3.org/1999/xhtml">
   <head>
     <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
     
     <meta name="Author" content="Martin Plicka; e-mail: plicka.m@atlas.cz" />
     <meta name="Generator" content="PSPad editor, www.pspad.com" />
     <meta name="Copyright" content="(c) Martin Plicka, 2007" />

     
     <meta http-equiv="Pragma" content="no-cache" />
     <meta http-equiv="Cache-Control" content="no-cache, must-revalidate" />
     <meta http-equiv="Expires" content="" />
     <meta http-equiv="Last-Modified" content="" />
     
     
     <link rel="stylesheet" href="css/style.css" media="screen" type="text/css" />
     <link rel="stylesheet" href="css/print.css" media="print" type="text/css" />
     
     <title>PhotoBase<? if (trim($TITLE) != "") echo " :: $TITLE";?></title>
   </head>
   <body>
   
     <div id="header">
   
       <a href="./"><img id="logo" src="img/logo.png" alt="logo.png, 8 kB" title="PhotoBase" width="140" height="95" /></a>
     
       <div id="menu">
         <a href="./news.php?what=photos">Nejnovější fota</a>
         <a href="./news.php?what=comments">Nejnovější komentáře</a>
         <?
         if (login_isLogged())
           echo "
             <a class=\"menu_clear\" href=\"./userlist.php\">Uživatelé</a>
           ";
         if (login_isLogged()) 
           echo "
             <a href=\"./edituser.php?id=".login_id()."\">Můj&nbsp;účet</a>
           ";
         if ( !login_isLogged() || login_isAdmin())
           echo "
             <a href=\"./register.php\">Registrace</a>
           ";
         ?>
       </div>
       
       <?
         if (basename($_SERVER["PHP_SELF"]) != "login.php")
            login_echoForm($_COOKIE["phb_lastlogin"],""); 
       ?>
    </div><!-- header -->
    
    <div class="navigation">
      <h1 class="location">
      <a href="./">PhotoBase</a> / <? echo $LOCATION; ?>
      </h1>
      
      <div class="pager">
        <? echo $PAGER; ?>
      </div>
    </div>
    
    <div id="spacer">
      <div id="main">
