<?php
/*
 *   PhotoBase, PHP & MySQL based web photo gallery
 *   Copyright 2007,2008 Martin Plicka
 *   
 *   This file is part of PhotoBase.
 *
 *   PhotoBase is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *   PhotoBase is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with PhotoBase.  If not, see <http://www.gnu.org/licenses/>.
 */     

/**
 * inc/setup.inc.php
 * 
 * Setup information
 * Nastaveni programu 
 *  
 * @version 0.9
 * @author Martin Plicka     
 */ 
 
/**
 * Authorization settings 
 * Nastaveni pristupovych udaju do databaze
 */       
$DB_HOST = "127.0.0.1";   //  MySQL server address / adresa MySQL serveru 
$DB_NAME = "phb";         //  database name / jmeno databaze
$DB_USER = "";            //  username / uzivatelske jmeno
$DB_PASS = "";            //  password / heslo

/**
 * number of items viewed at default
 * vychozi pocet zobrazenych polozek na strance
 */          
$LIMIT_CAT = 3;         // category list / vypis kategorii
$LIMIT_GAL = 3;         // gallery list / vypis galerii
$LIMIT_PHOTOS = 10;     // photos list / vypis fotografii
$LIMIT_USERS = 15;      // users list / vypis uzivatelu
$LIMIT_COMMENTS = 15;   // newest comments list / vypis nejnovejsich komentaru

/**
 * Maximum upload size
 * Maximalni velikost fotografie pro upload
 */       
$UPLOAD_MAX_SIZE = 2*1024*1024; // in Bytes / v Bytech
$UPLOAD_MAX_SIZE_HR = '2 MB';   // As a text to be printed on page / Jako text pro vypis na stranku


/**
 * Allowed thumbnail sizes, for correct behavior, 0-2 must be set.
 * Povolene velikosti nahledu, pro spravnou funkcnost musi byt nastaveny 0-2
 * 0 - gallery / galerie
 * 1 - single view / zobrazeni jednoho
 * 2 - kategory or gallery thumbnail / nahled u kategorie nebo galerie
 * 
 * WARINIG: When changing sizes, CSS definition is needed. Otherwise, layout can be broken.
 *          After changing size, you must delete old thumbnail files in chache located in thumb/ subdirectory.
 *          Their names are in format "width-height-filename.jpg".  
 *   
 * POZOR: Zmene rozmeru musi odpovidat i zmena CSS definic. Pri nedodrzeni muze dojit k poruseni spravneho layoutu.    
 *        Pokud zmenite rozmery, je nutne smazat stare soubory nahledu z cache v podadresari /thumbs, 
 *        ktere jsou ve tvaru sirka-vyska-jmeno_souboru.jpg      
 */       
$THUMB_SIZE[] = Array (
      "w" => 110,
      "h" => 90
);
$THUMB_SIZE[] = Array (
      "w" => 500,
      "h" => 375
);
$THUMB_SIZE[] = Array (
      "w" => 50,
      "h" => 50
);

 
/**
 * check settings, DO NOT EDIT
 * kontrola vseho, NEMENIT
 */
 
if (!isset($DB_HOST)) { echo "CHYBA SETUPU: v konfiguracnim souboru chybi nastaveni adresy MySQL serveru"; exit;}
if (!isset($DB_NAME) || $DB_NAME=="") { echo "CHYBA SETUPU: v konfiguracnim souboru chybi nastaveni jmena databaze"; exit;}
if (!isset($DB_USER)) { echo "CHYBA SETUPU: v konfiguracnim souboru chybi nastaveni uzivatelskeho jmena MySQL serveru"; exit;}
if (!isset($DB_PASS)) { echo "CHYBA SETUPU: v konfiguracnim souboru chybi nastaveni hesla MySQL serveru"; exit;}

if (!is_array($THUMB_SIZE) || count($THUMB_SIZE)<3) { echo "CHYBA SETUPU: v konfiguracnim souboru chybi spravna definice velikosti nahledu"; exit; }
foreach ($THUMB_SIZE as $__pole) {
    if (!isset($__pole["h"]) || !isset($__pole["w"])) { echo "CHYBA SETUPU: v konfiguracnim souboru chybi rozmery velikosti nahledu"; exit;} 
}
?>
