<?php
/*
 *   PhotoBase, PHP & MySQL based web photo gallery
 *   Copyright 2007,2008 Martin Plicka
 *   
 *   This file is part of PhotoBase.
 *
 *   PhotoBase is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *   PhotoBase is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with PhotoBase.  If not, see <http://www.gnu.org/licenses/>.
 */     

/**
 * inc/tools.inc.php
 * 
 * Various purposes functions
 *  
 * @version 0.9
 * @author Martin Plicka     
 */ 
 
require_once './inc/setup.inc.php';
 
/**
 * Redirect to given URL, works if headers haven't been sent yet.
 * @param url taget URL
 */  
function location ($url) {
      header ("Location: $url");
      exit;
}

/**
 * Prints out error
 * @param desc error text
 */  
function error($desc){
    if (headers_sent()) {
       $DB_NO_CONNECTION = 1;
       echo "<h1>Chyba</h1>
            <div style=\"report\">".hsc($desc);
       echo ". <a href=\"javascript:history.go(-1)\">Zpět</a>, <a href=\"./\">Domů</a>";
       echo '</div>';   
       include "./inc/footer.inc.php";
       exit;
    }
    else {
       $LOCATION  = "Chyba !!!";
       $DB_NO_CONNECTION = 1;
       include "./inc/header.inc.php";
       echo "<h1>Chyba</h1>
            <div style=\"report\">".hsc($desc);
       echo ". <a href=\"javascript:history.go(-1)\">Zpět</a>, <a href=\"./\">Domů</a>";
       echo '</div>';   
       include "./inc/footer.inc.php";
      exit;
    }
}

/**
 * add slashes, when magic_quotes_gpc are disabled
 * @param string text
 * @return safe text
 */   
function safe_gpc($string){
   if (get_magic_quotes_gpc()) return $string; else return addslashes($string);
}

/**
 * strip slashes, when magic_quotes_
 * @param string text
 * @return unsafe text
 */   
function unsafe_gpc($string){
   if (!get_magic_quotes_gpc()) return $string; else return stripslashes($string);
}

/**
 * calls safe_gpc for POST varible
 * @param name POST variable name
 * @return safe text  
 */ 
function safe_post($name){
  return isset($_POST[$name])?trim(safe_gpc($_POST[$name])):"";
}

/**
 * calls unsafe_gpc for POST varible
 * @param name POST variable name
 * @return unsafe text  
 */ 
function unsafe_post($name){
  return isset($_POST[$name])?trim(unsafe_gpc($_POST[$name])):"";
}

/**
 * htmlspecialchars() alias
 */   
function hsc($string){
  return htmlspecialchars($string);
}

?>
