<?php


/*
 *   PhotoBase, PHP & MySQL based web photo gallery
 *   Copyright 2007,2008 Martin Plicka
 *   
 *   This file is part of PhotoBase.
 *
 *   PhotoBase is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *   PhotoBase is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with PhotoBase.  If not, see <http://www.gnu.org/licenses/>.
 */     

/**
 * news.php
 * 
 * Shows all photos/comments sorted by time posted, in descending order
 *  
 * @version 0.9
 * @author Martin Plicka
 *   
 * Parametres:     
 *  GET[what] =  photos
 *               comments
 * GET[page]  = page number, 0 = newest
 * GET[limit] = number of items per page  
 */
   
require_once "./inc/login.inc.php";
require_once './inc/db.inc.php';
require_once './inc/setup.inc.php';
    
$what = isset($_GET["what"])?$_GET["what"]:"photos";

// offset, min 0
$page = isset($_GET["page"])?(int)$_GET["page"]:0;
if ($page<0) $page = 0;


/************* pocet stranek ******************/
switch ($what){
 case "comments":
      $query="SELECT count(id) as count FROM comments;";
      break;
 
 case "photos": 
 default:
     $query="SELECT count(id) as count FROM photos;";
     $what = "photos";
     break;
 
}

// limit, min 1
$limit_default = "LIMIT_".strtoupper($what);
$limit = isset($_COOKIE[$limit_default])?(int)$_COOKIE[$limit_default]:$$limit_default;
if ($limit<=0) $limit = $$limit_default;

if (isset($_GET["limit"]) && is_numeric($_GET["limit"]) && ((int)$_GET["limit"]) > 0 ){
   $limit = (int)$_GET["limit"];
   setcookie($limit_default, $limit,time()+60*60*24*30);
}


$res = db_query($query);
if (db_empty($res)) db_error("Chyba databaze");
$row = mysql_fetch_row($res);
mysql_free_result($res);
$count = $row[0];

$maxpage = max(0,ceil($count / $limit) - 1);
if ($page > $maxpage) $page = $maxpage;

/*************** PAGER************************/

$min = max($page-4,0);
$max = min($page+4, $maxpage);

//ktera cisla budeme vypisovat, tak nahazime do pole
$pole[]=0; //prvni stranka
for ($i = $min+1; $i<$max; $i++) {
 $pole[]=$i; //3 okolo aktualni stranky
}
if ($maxpage!=0) $pole[]=($maxpage); //posledni stranka


if ($page > 0) $PAGER.= "<a href=\"./news.php?what=$what&amp;limit=$limit&amp;page=".($page-1)."\">&lt;</a> ";
for ($i = 0; $i<count($pole); $i++) {
    if ($i == 1 && $pole[0]<$pole[1]-1) $PAGER.= ".. ";
    if ($page!=$pole[$i])
        $PAGER.= "<a href=\"./news.php?what=$what&amp;limit=$limit&amp;page=".($pole[$i])."\">".($pole[$i]+1)."</a> ";
    else $PAGER.= "<a class=\"actual\">".($pole[$i]+1)."</a> ";
    if ($i == count($pole)-2 && $pole[$i]<$pole[$i+1]-1) $PAGER.= ".. ";
}
if ($page < $maxpage) $PAGER.= "<a href=\"./news.php?what=$what&amp;limit=$limit&amp;page=".($page+1)."\">&gt;</a> ";


/**************** LOCATION ********************/
switch ($what){
 
 case "photos":
    $LOCATION = $TITLE = "Novinky: fotografie";
    break;
    
 case "comments":
    $LOCATION = $TITLE = "Novinky: komentáře";
    break;
 
}


/***************** VYPIS ************************/
include "./inc/header.inc.php";

echo "<div id=\"limiter\">Zobrazovat položek: 
<form action=\"./news.php\" method=\"get\">
<input type=\"hidden\" name=\"what\" value=\"$what\" />
<input type=\"hidden\" name=\"page\" value=\"$page\" /> 
<select name=\"limit\" onchange=\"submit();\">\n";
if ($what == "photos") {
  if ($limit != 10 && $limit != 20 && $limit != 40 && $limit != 60)echo "<option value=\"x\">(vyberte)</option>";
  echo "
  <option value=\"10\"".($limit==10?" selected=\"selected\"":"").">10</option>
  <option value=\"20\"".($limit==20?" selected=\"selected\"":"").">20</option>
  <option value=\"40\"".($limit==40?" selected=\"selected\"":"").">40</option>
  <option value=\"60\"".($limit==60?" selected=\"selected\"":"").">60</option>
  ";
}
else {
  if ($limit != 4 && $limit != 8 && $limit != 12 && $limit != 16)echo "<option value=\"x\">(vyberte)</option>";
  echo "
  <option value=\"15\"".($limit==15?" selected=\"selected\"":"").">15</option>
  <option value=\"30\"".($limit==30?" selected=\"selected\"":"").">30</option>
  <option value=\"45\"".($limit==45?" selected=\"selected\"":"").">45</option>
  <option value=\"60\"".($limit==60?" selected=\"selected\"":"").">60</option>
  ";
}

echo "</select><input type=\"submit\" value=\"OK\"/></form></div>\n";
$offset = $page * $limit;

switch ($what){
 case "comments":
    $query="SELECT c.id, c.text, DATE_FORMAT(c.time,'%e.%m.%Y - %H:%i'), u.name, p.id, p.url, g.name, cat.name, CASE WHEN TRIM(p.description)!='' THEN p.description ELSE p.url END FROM comments c JOIN photos p ON (p.id = c.photo) JOIN users u ON (u.id = c.user) JOIN galleries g ON (g.id = p.gallery) JOIN categories cat ON (cat.id = g.category) ORDER BY c.id DESC LIMIT $offset, $limit;";
    break;
 
 case "photos":
    if (login_isCreator() && $owner == login_id()) echo "<div class=\"admin\"><a href=\"./editphoto.php?action=new&amp;gallery=$id\">Vložit fotografii</a></div>";
    $query="SELECT p.id, p.description, url, DATE_FORMAT(p.time,'%e.%m.%Y - %H:%i'), count(c.id), u.name FROM photos p JOIN galleries g ON (g.id = p.gallery) JOIN users u ON (u.id = g.user) LEFT JOIN comments c ON (c.photo = p.id) GROUP BY p.id ORDER BY p.id DESC LIMIT $offset, $limit;";
    break;
}

$res = db_query($query);
if (db_empty($res)) echo "<div class=\"list_empty\">Žádné položky</div>";
echo "<br class=\"hide\" /><div id=\"list_$what\">\n";
switch ($what){
  case "comments": 
    while ($row = mysql_fetch_array($res)){
      echo "<div class=\"list_item\">";
      if ($row[5] != "")
      echo "<div class=\"list_thumb\"><img src=\"./thumb.php?src=".urlencode($row[5])."&amp;size=2\" alt=\"Nahled\" /></div>";
      echo"<h2 class=\"list_head\"><a href=\"./view.php?id={$row[4]}#comm{$row[0]}\">".hsc($row[7])." / ".hsc($row[6])." / ".hsc($row[8])."</a></h2>\n";
      echo "<div class=\"list_body\">".nl2br(hsc($row[1]))."<div class=\"time\">Vložil ".hsc($row[3])."<br />{$row[2]}</div>";
      
      /*
      if (login_id()==$row[4] || login_isAdmin()) {
        echo "<div class=\"admin\">\n";
        if (login_id()==$row[4]) echo "<a href=\"./editphoto.php?action=new&amp;gallery={$row[0]}\">Vložit fotografii</a> - ";
        echo "<a href=\"./editgal.php?action=edit&amp;id={$row[0]}\">Editovat</a> - 
        <a href=\"./editgal.php?action=delete&amp;id={$row[0]}\">Smazat</a>";
        echo "</div>\n";
      }
      */
      echo "</div></div><br class=\"hide\" />\n";
    }
    break;
 
  case "photos": 
    while ($row = mysql_fetch_array($res)){
        
        echo "<div class=\"thumb\" title=\"".hsc($row[1])."\"><a href=\"./view.php?id=".$row[0]."\">";
        echo "<img alt=\"Nahled\" src=\"./thumb.php?size=0&amp;src=".urlencode($row[2])."\" /></a>";
        echo "<div class=\"time\">".hsc($row[3])."<br />{$row[4]} komentářů</div>";
        echo "</div>\n<br class=\"hide\" />\n";
      
    }
    echo "\n<br class=\"clear\" />\n";
    break;
 
}

mysql_free_result($res);
echo "</div><br class=\"clear\" />\n";

include "./inc/footer.inc.php";
?>
