<?php



/*
 *   PhotoBase, PHP & MySQL based web photo gallery
 *   Copyright 2007,2008 Martin Plicka
 *   
 *   This file is part of PhotoBase.
 *
 *   PhotoBase is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *   PhotoBase is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with PhotoBase.  If not, see <http://www.gnu.org/licenses/>.
 */     

/**
 * register.php
 * 
 * Registers new user
 *  
 * @version 0.9
 * @author Martin Plicka
 *   
 * Parametres:     
 *   GET[state] 0 - form
 *              1 - acknowledgement
 *   POST[send] - submit button
 *   POST[name]
 *   POST[loginname]
 *   POST[email]
 *   POST[pass1]
 *   POST[pass2]
 *   POST[wantcreate] = user wants to create galleries
 */
 
require_once './inc/login.inc.php';
require_once './inc/tools.inc.php'; 
 
if (login_isLogged() && !login_isAdmin()) error("Registrace je jen pro neregistrované uživatele.");
$state = isset($_GET["state"])?(int)$_GET["state"]:0;


switch ($state) {
  case 1:
         include "./inc/header.inc.php";
         echo "<H1>Provedeno</H1>
         <p>Účet byl zaregistrován. \n";
         if (!login_isAdmin()) echo "<a href=\"./login.php?username={$_GET["username"]}\">Přihlásit se</a>.";
         echo "</p>";
         include "./inc/footer.inc.php";
         
         break;
  default:
    $name="";
    $loginname="";
    $email="";
    $pass1="";
    $pass2="";
    $wantcreate=0;
    
    $break = false;
    $msg = "";
    if (isset($_POST["send"])) {
          $PAGER = "Krok 2";
          $name=unsafe_post("name");
          $loginname=unsafe_post("loginname");
          $email=unsafe_post("email");
          $pass1=unsafe_post("pass1");
          $pass2=unsafe_post("pass2");
          
          $wantcreate=(int)unsafe_post("wantcreate");
          if (! ereg("[[:alpha:]]{2,}",$name)) {
              $msg.="Jméno musí obsahovat alespoň 2 písmena za sebou.<br />"; $break=true;
          }
          if (! ereg("^[a-zA-Z][a-zA-Z0-9_]{3,}$",$loginname)) {
              $msg.="Pro přihlašovací jméno jsou dovoleny jen alfanumerické znaky a podtržítko. Minimální délka jsou 4 znaky.<br />"; $break=true;
          }
          if (! ereg("^[_a-zA-Z0-9\.\-]+@[_a-zA-Z0-9\.\-]+\.[a-zA-Z]{2,4}$",$email)) {
              $msg.="Neplatný formát emailu.<br />"; $break=true;
          }
          
          if (strlen($pass1)<5) {
              $msg.="Heslo musi byt alespon 5 znaku<br />"; $break=true;
          }
          else if ($pass1 != $pass2) {
              $msg.="Hesla v obou polickach nesouhlasi<br />"; $break = true;
          }
          
          if (!isset($_POST["vcode"]) || !isset($_SESSION["vcode_register"]) || $_SESSION["vcode_register"] != $_POST["vcode"]) {
              $msg.="Nesprávně opsaný bezpečnostní kód"; $break=true;
          }
          
          if (! $break) {
              $name1 = safe_post("name");
              $loginname1 = safe_post("loginname");
              $email1 = safe_post("email");
              $pass11 = md5($pass1);
              $query = "INSERT INTO users (name, login, pass, email".($wantcreate?", rights":"").") VALUES "
                 ."('$name1','$loginname1','$pass11','$email1'".($wantcreate?", 'commentator,wantcreate'":"").");";
              $res = db_query($query,false);
              if ($res) location("./register.php?state=1&username=".urlencode($loginname));
              if (mysql_errno() > 0 && mysql_errno() != 1062) db_error (mysql_errno());
              $msg = "Neplatné přihlašovací jméno, již existuje";
          }
    }
    else $PAGER="Krok 1";
        
    $LOCATION = "Registrace  nového uživatele";
    $TITLE = "Registrace";
    include "./inc/header.inc.php";
    
    ?>
    
    <script type="text/javascript">
      <!--
            function check_reg(){
                a = document.getElementById("name1");
                if (! /[^ ]{2}/.test(a.value)) {
                    window.alert("Neplatné jméno, musí obsahovat alespoň dvě písmena za sebou");
                    a.focus();
                    return false;
                }
                a = document.getElementById("loginname1");
                if (! /^[a-zA-Z][a-zA-Z0-9_]{3,}$/.test(a.value)) {
                    window.alert("Neplatné přihlašovací jméno, jsou povoleny jen alfanumerické znaky a podtržítko, ne však jako první, minimální délka 4 znaky");
                    a.focus();
                    return false;
                }
                a = document.getElementById("email1");
                if (! /^[_a-zA-Z0-9\.\-]+@[_a-zA-Z0-9\.\-]+\.[a-zA-Z]{2,4}$/.test(a.value)) {
                    window.alert("Neplatný email");
                    a.focus();
                    return false;
                }
                a = document.getElementById("pass11");
                b = document.getElementById("pass21");
                if (a.value.length < 5){
                    window.alert("Heslo musí být minimálně 5 znaků");
                    a.focus();
                    return false;
                }
                else if (a.value != b.value){
                    window.alert("Hesla v obou políčkách se neshodují");
                    b.focus();
                    return false;
                }
                a = document.getElementById("vcode1");
                if (! /^[0-9]{5}$/.test(a.value)) {
                    window.alert("Tak tohle určitě není pětimístný kód");
                    a.focus();
                    a.select();
                    return false;
                }
                return true;
            }
            
            function color_name() {
                a = document.getElementById("name1");
                if (! /[^ ]{2}/.test(a.value)) 
                   a.style.background = '#ffcc99';
                else 
                   a.style.background = 'none';
            }
            
            
            function color_loginname() {
                a = document.getElementById("loginname1");
                if (! /^[a-zA-Z][a-zA-Z0-9_]{3,}$/.test(a.value)) 
                   a.style.background = '#ffcc99';
                else 
                   a.style.background = 'none';
            }
            
            function color_email() {
                a = document.getElementById("email1");
                if (! /^[_a-zA-Z0-9\.\-]+@[_a-zA-Z0-9\.\-]+\.[a-zA-Z]{2,4}$/.test(a.value)) 
                   a.style.background = '#ffcc99';
                else 
                   a.style.background = 'none';
            }
            
            function color_pass (){
                a = document.getElementById("pass11");
                b = document.getElementById("pass21");
                if (a.value.length < 5 ){
                    a.style.background = '#ffcc99';
                    b.style.background = 'none';
                }
                else if (a.value != b.value){
                    b.style.background = '#ffcc99';
                    a.style.background = 'none';
                }
                else {
                    a.style.background = 'none';
                    b.style.background = 'none';         
                }
            
            }
            
            function vcode_new(){
                 if (a = document.getElementById('vcode')) {
                     if (isNaN(a.flag)) a.flag=0;
                     a.flag = a.flag + 1;
                     a.src = 'img/vcode.php?code=register&i='+a.flag;
                 }
            }
           //-->
    </script>
    
    <?
    
    echo "
    <div class=\"error\">$msg</div>
    <form action=\"./register.php\" method=\"post\" onsubmit=\"return check_reg();\">
    <label for=\"name1\" class=\"mandatory\">Vaše jméno * (bude se zobrazovat u galerií, příspěvků)</label><input type=\"text\" name=\"name\" value=\"".hsc($name)."\" maxlength=\"30\" id=\"name1\" onkeyup=\"color_name();\" /><br />
    <label for=\"loginname1\" class=\"mandatory\">Přihlašovací jméno * (min. 4 alfanumerické znaky nebo podtržítko)</label><input type=\"text\" name=\"loginname\" value=\"".hsc($loginname)."\" maxlength=\"20\" id=\"loginname1\" onkeyup=\"color_loginname();\" /><br />
    <label for=\"email1\" class=\"mandatory\">E-mail *</label><input type=\"text\" name=\"email\" value=\"".hsc($email)."\" maxlength=\"50\" id=\"email1\" onkeyup=\"color_email();\" /><br />
    <label for=\"pass11\" class=\"mandatory\">Heslo * (min. 5 znaků)</label><input type=\"password\" name=\"pass1\" value=\"".hsc($pass1)."\" id=\"pass11\" onkeyup=\"color_pass();\" /><br />
    <label for=\"pass21\" class=\"mandatory\">Heslo znovu *</label><input type=\"password\" name=\"pass2\" value=\"".hsc($pass2)."\" id=\"pass21\" onkeyup=\"color_pass();\" /><br />
    <input class=\"inline\" type=\"checkbox\" name=\"wantcreate\" id=\"wantcreate1\" value=\"1\"".(($wantcreate==1)?" checked=\"checked\"":"")."/><label class=\"inline\" for=\"wantcreate1\">Chci vytvářet vlastní galerie fotek (zaškrtněte).</label><br />
    <label for=\"vcode1\" class=\"mandatory\">Opište následující kód * 
     <script type=\"text/javascript\">
      <!--
      document.write('(při nečitelnosti klikněte na obrázek, vygeneruje se nový)');
      -->
     </script>
     </label>
    <img id=\"vcode\" src=\"./img/vcode.php?code=register\" alt=\"Opište\" title=\"Klikněte pro vygenerování nového kódu\" onclick=\"vcode_new(); \"/>
    <input class=\"inline\" type=\"text\" maxlength=\"5\" name=\"vcode\" id=\"vcode1\" /><br />
    <br />Povinné položky jsou označeny hvězdičkou.<br />
    <input type=\"submit\" name=\"send\" value=\"Odeslat\" />
    
                                   
    </form>
    ";
    include "./inc/footer.inc.php";
  break;
}  
?>
