<?php

/*
 *   PhotoBase, PHP & MySQL based web photo gallery
 *   Copyright 2007,2008 Martin Plicka
 *   
 *   This file is part of PhotoBase.
 *
 *   PhotoBase is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *   PhotoBase is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with PhotoBase.  If not, see <http://www.gnu.org/licenses/>.
 */     

/**
 * view.php
 * 
 * Shows photography info and comments
 *  
 * @version 0.9
 * @author Martin Plicka
 *   
 * Parametres:     
 *   GET[id] - photo ID
 */     
                   

require_once './inc/db.inc.php';
require_once './inc/login.inc.php';

$id = isset($_GET["id"])?(int)$_GET["id"]:1;
$id = $id>0?$id:1;

$res = db_query("SELECT p.description, p.url, g.id, g.name, c.id, c.name, g.user FROM photos p JOIN galleries g ON (g.id = p.gallery) JOIN categories c ON (c.id = g.category) WHERE p.id = $id;");
db_error_on_empty($res);
$row = mysql_fetch_row($res);
mysql_free_result($res);

$owner = $row[6];
$TITLE = "Fotografie: ". (trim($row[0])!=""?trim($row[0]):"(bez popisku)");
$LOCATION = "<a href=\"./list.php?what=gal&amp;id={$row[4]}\">".hsc($row[5])."</a> / <a href=\"./list.php?what=photos&amp;id={$row[2]}\">".hsc($row[3])."</a> / {$row[1]}";


/**
 * get previous and next photo within current gallery
 */ 

$gal_id = $row[2];
$res = db_query("SELECT id FROM photos WHERE id > $id AND gallery=$gal_id ORDER BY id LIMIT 1;");
if (db_empty($res)) { //no newer
   $PAGER = "";
}
else {
   $tmp = mysql_fetch_row($res);
   $PAGER = "<span style=\"margin-right: 7ex;\"><a href=\"./view.php?id={$tmp[0]}\" title=\"Předchozí (novější) foto v galerii\">&lt;&lt;</a></span>";
}
mysql_free_result($res);

$res = db_query("SELECT id FROM photos WHERE id < $id AND gallery=$gal_id ORDER BY id DESC LIMIT 1;");
if (!db_empty($res)) { //when older exists
   $tmp = mysql_fetch_row($res);
   $PAGER .= "<span style=\"margin-left: 7ex;\"><a href=\"./view.php?id={$tmp[0]}\" title=\"Další (starší) foto v galerii\">&gt;&gt;</a></span>";
}
mysql_free_result($res);


include "./inc/header.inc.php";

//owner of admin
if (login_id() == $owner || login_isAdmin()) {
  echo "
      <div class=\"admin\">
      <a href=\"./editphoto.php?action=edit&amp;id=$id\">Upravit</a>
       -
      <a href=\"./editphoto.php?action=delete&amp;id=$id\">Smazat</a>
      </div>
  ";
}

echo "
    <div id=\"view_img\">
    <a href=\"./photos/{$row[1]}\" target=\"_blank\"><img src=\"./thumb.php?size=1&amp;src=".urlencode($row[1])."\" alt=\"Náhled\" title=\"Klikněte pro zobrazení v plné velikosti\" /></a>
    </div>
";

if (strlen(trim($row[0]))>0) echo "
   <h2 id=\"view_description\">".hsc($row[0])."</h2>";


/**
 * EXIF output
 */ 
if ($exif = @exif_read_data("./photos/".$row[1], "ANY_TAG", true)){
   echo "
      <div id=\"view_exif\">
      <table id=\"exif\" summary=\"EXIF tagy\">
   ";

   if (isset($exif["IFD0"]["Make"]))
      echo "<tr><th>Výrobce:</th><td>{$exif["IFD0"]["Make"]}</td></tr>
      ";
  
   if (isset($exif["IFD0"]["Model"]))
      echo "<tr><th>Model:</th><td>{$exif["IFD0"]["Model"]}</td></tr>
      ";
  
   if (isset($exif["EXIF"]["DateTimeOriginal"]))
      echo "<tr><th>Čas pořízení:</th><td>{$exif["EXIF"]["DateTimeOriginal"]}</td></tr>
      ";
      
   if (isset($exif["EXIF"]["ExifImageWidth"]))
      echo "<tr><th>Původní rozměry:</th><td>{$exif["EXIF"]["ExifImageWidth"]} x {$exif["EXIF"]["ExifImageLength"]}</td></tr>
      ";
  
   if (isset($exif["COMPUTED"]["ApertureFNumber"]))
      echo "<tr><th>Clona:</th><td>{$exif["COMPUTED"]["ApertureFNumber"]}</td></tr>
      ";
      
   if (isset($exif["EXIF"]["ISOSpeedRatings"]))
      echo "<tr><th>ISO:</th><td>{$exif["EXIF"]["ISOSpeedRatings"]}</td></tr>
      ";
      
   if (isset($exif["EXIF"]["ExposureTime"])) {
      list ($c, $j) = explode("/",$exif["EXIF"]["ExposureTime"],2);
      echo "<tr><th>Doba expozice:</th><td>".(($c/$j>1)?($c/$j):("1/".$j/$c))." s</td></tr>
      ";
   }
    
   if (isset($exif["EXIF"]["FocalLength"])) {
      list ($c, $j) = explode("/",$exif["EXIF"]["FocalLength"],2);
      echo "<tr><th>Ohnisková vzdálenost:</th><td>".($c/$j)." mm</td></tr>
      ";
   }

   echo "
      </table>
      <br />
      </div>
   ";
}

/*
RAW output:
  foreach ($exif as $key => $section) {
    foreach ($section as $name => $val) {
        echo "$key.$name: $val<br />\n";
    }
  }
*/

echo "
   <div id=\"view_addcomment\">
";

if (login_isCommentator()) {
  echo "
    <h2>Vložit komentář</h2>
    
    <script type=\"text/javascript\">
        <!--
        function check_comment(){
           a = document.getElementById('text1');
           if (! /[^ \\n]/.test(a.value)) {
             window.alert('Musíte něco napsat');
             a.focus();
             return false;
           }
           if (a.value.length>1000) {
             window.alert('Moc dlouhý komentář, je povoleno max. 1 000 znaků.');
             a.focus();
             return false;
           }
           return true;
        }
        -->
    </script>
    
    <form action=\"comment.php?action=new\" method=\"post\" onsubmit=\"return check_comment();\">
       <input type=\"hidden\" name=\"photo\" value=\"$id\" />
       <textarea name=\"text\" id=\"text1\" cols=\"50\" rows=\"5\"></textarea><br />
       <input name=\"send\" type=\"submit\" value=\"Odeslat\" />
    </form>";
}

else if (login_isLogged()){
   echo "Administrátor vám nedovolil komentovat fotografie";
}
else {
   echo "Komentáře lze vkládat až po <a href=\"login.php?goback=".urlencode($_SERVER["REQUEST_URI"])."\">přihlášení</a>";
}

echo "
    </div>
";


$query = "SELECT c.id, c.text, DATE_FORMAT(c.time,'%e.%m.%Y - %H:%i'), u.name, u.id FROM comments c JOIN users u ON (c.user = u.id) WHERE c.photo = $id ORDER BY c.id DESC;";
$res = db_query($query);

if (!db_empty($res)) {
   
   echo "
      <div id=\"view_comments\">
      <a name=\"comm\"></a><h2>Komentáře</h2><div id=\"comments_scroll\">
   ";
   
   $i = 0;
   while ($row = mysql_fetch_row($res)) {
      $i ++;
      echo "
         <div class=\"".($i % 2?"odd_":"even_")."item\">
      ";
      if (login_isModerator() || login_id() == $owner || login_id()==$row[4]) {
         echo "
            <a href=\"comment.php?action=delete&amp;id={$row[0]}\">Smazat</a>
         ";
      }
      echo "
         <div>
         <a class=\"hide\" name=\"comm{$row[0]}\"></a>
         {$row[2]} - 
         ".hsc($row[3])."
         </div>".nl2br(hsc($row[1]))."
     
         </div>
         <br class=\"hide\"/>
      ";
   }
   echo "
     </div>
    </div>
   ";
}

mysql_free_result($res);

include "./inc/footer.inc.php";


?>
